<?php
// ------------------------------------------------------------------------- //
//                Geeklog - PHP Content Management System                    //
// ------------------------------------------------------------------------- //
// Story Migration Utility for Geeklog to the Forum                          //
// By: Blaine Lang  -  July 5th 2003    geeklog@langfamily.ca                //
//                                                                           //
// ------------------------------------------------------------------------- //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
// ------------------------------------------------------------------------- //

// Place this program in the public_html/admin/plugins/forum directory

require_once("../../../lib-common.php");

if (!SEC_hasRights('forum.edit')) {
  echo COM_siteHeader();
  echo COM_startBlock($LANG_GF00['access_denied']);
  echo $LANG_GF00['admin_only'];
  echo COM_endBlock();
  echo COM_siteFooter(true);
  exit();
}

echo '<script language="javascript">
	<!-- Begin
	var allChecked;
	function checkAll(field)
	{
	allChecked=true;
	for (i = 0; i < field.length; i++)
		field[i].checked = true ;
	}
	
	function uncheckAll(field)
	{
	allChecked=false;
	for (i = 0; i < field.length; i++)
		field[i].checked = false ;
	}
	function confirmSubmit(text) { 
	  var yes = confirm(text); 
	  if (yes) return true; 
	  else return false; 
	} 

	//  End -->
	</script>';

// Debug Code to show variables
/*
if (!empty($HTTP_POST_VARS)) {
    echo "HTTP_POST_VARS:<br>";
	var_dump($HTTP_POST_VARS);
	echo "<hr>";
}
if (!empty($HTTP_GET_VARS)) {
    echo "HTTP_GET_VARS:<br>";
	var_dump($HTTP_GET_VARS);
	echo "<hr>";
}
*/

if ($HTTP_POST_VARS['migrate'] == "Migrate Selected Topics" AND $HTTP_POST_VARS['selforum'] != "select" AND !empty( $HTTP_POST_VARS['cb_chkentry']) ) {
	$num_stories = 0;
	$num_posts = 0;
	foreach($cb_chkentry as $sid ) {
		$topic = DB_getItem($_TABLES['stories'],"tid","sid='$sid'");
		$forum = $HTTP_POST_VARS['selforum'];
		//echo "<br>Migrating SID:$sid for Topic: $topic to Forum: $forum";
		$sql = DB_query("SELECT sid,tid,date,uid,title,introtext,bodytext,hits from {$_TABLES['stories']} WHERE sid='$sid'");
		list($sid,$tid,$storydate,$uid,$subject,$introtext,$bodytext,$hits) = DB_fetchARRAY($sql);
		$num_posts = migratetopic($forum,$sid,$tid,$storydate,$uid,$subject,$introtext,$bodytext,$hits) + $num_posts;
		$num_stories++;
	}

	echo COM_refresh($_CONF['site_admin_url'] . "/plugins/forum/migrate.php?num_stories=". $num_stories. "&num_posts=".$num_posts);
	exit;
}

function migratetopic($forum,$sid,$tid,$storydate,$uid,$subject,$introtext,$bodytext,$hits) {
	global $_TABLES;
	$comment = $introtext . $bodytext;
	$comment = prepareStringForDB($comment);
	$subject = prepareStringForDB($subject);
	$postmode = "HTML";
	$name = DB_getITEM($_TABLES['users'],'username',"uid=$uid");
	$email = DB_getITEM($_TABLES['users'],'email',"uid=$uid");
	$website = DB_getITEM($_TABLES['users'],'homepage',"uid=$uid");

	$datetime = explode(" ", $storydate);
	$date = explode("-",$datetime[0]);
	$time = explode(":",$datetime[1]);
	$year  = ($date[0] > 1969) ? $date[0] : "2001";
	$month = $date[1];
	$day   = $date[2];
	$hour  = $time[0];
	$min   = $time[1];
	$timestamp = mktime($hour,$min,0,$month,$day,$year);

	DB_query("INSERT INTO {$_TABLES['gf_topic']} (forum,name,date,lastupdated, email, website, subject, comment, views, postmode, ip, mood, uid, pid, sticky, locked) 
		VALUES ('$forum','$name','$timestamp','$timestamp','$email','$website','$subject','$comment','$hits','$postmode','','','$uid','0','0','0')");
	$parent = DB_insertID();
	$i++;
	$comments = migrateComments($forum,$sid, $parent);
	$num_posts = $num_posts + $comments;
	return $num_posts;
}


function migrateComments($forum,$sid, $parent) {
	global $verbose,$_TABLES,$_CONF,$migratedcomments;
	$sql = DB_query("SELECT sid,date,uid,title,comment from {$_TABLES['comments']} WHERE sid = '".$sid."' ORDER BY date ASC");
	$num_comments = DB_numROWS($sql);
	if ($verbose) {
	    echo "Found $num_comments Comments to migrate for this topic";
    }
	$i = 0;
	while ( list($sid,$commentdate,$uid,$subject,$comment) = DB_fetchARRAY($sql)) {

		$sqlid = DB_query("SELECT id from {$_TABLES['gf_topic']} ORDER BY id desc LIMIT 1");
		list ($lastid) = DB_fetchARRAY($sqlid);

		$comment = prepareStringForDB($comment);
		$subject = prepareStringForDB($subject);
		$postmode = "HTML";
		$name = DB_getITEM($_TABLES['users'],'username',"uid=$uid");
		$email = DB_getITEM($_TABLES['users'],'email',"uid=$uid");
		$website = DB_getITEM($_TABLES['users'],'homepage',"uid=$uid");

		$datetime = explode(" ", $commentdate);
		$date = explode("-",$datetime[0]);
		$time = explode(":",$datetime[1]);
		$year  = ($date[0] > 1969) ? $date[0] : "2001";
		$month = $date[1];
		$day   = $date[2];
		$hour  = $time[0];
		$min   = $time[1];
		$timestamp = mktime($hour,$min,0,$month,$day,$year);
		$lastupdated = $timestamp;
		$migratedcomments++;

		DB_query("INSERT INTO {$_TABLES['gf_topic']} (forum,name,date,lastupdated, email, website, subject, comment, postmode, ip, mood, uid, pid, sticky, locked) 
			VALUES ('$forum','$name','$timestamp','$lastupdated','$email','$website','$subject','$comment','$postmode','','','$uid','$parent','0','0')");
		$i++;
	}

	DB_query("UPDATE {$_TABLES['gf_topic']} SET replies = $num_comments WHERE id=$parent");
	return $num_comments;
}

function prepareStringForDB($message,$postmode="html",$censor=TRUE,$htmlfilter=TRUE) {
	if ($censor) {
	    $message = COM_checkWords($message);
	}
    if($postmode == 'html') {
        if ($htmlfilter) {
            // Need to call addslahes again as COM_checkHTML stips it out
	        $message = addslashes(COM_checkHTML($message));
		} elseif (!get_magic_quotes_gpc() ) {
		    $message = addslashes($message);
		}	
	} else {
		if(get_magic_quotes_gpc() ) {
		    $message = htmlspecialchars($message);
		} else {	
		    $message = addslashes(htmlspecialchars($message));
		}	
	}	
	return $message;
}



echo COM_siteHeader('menu');

// Check if the number of records was specified to show
if (empty($show)) {
    $show = 20;
}
// Check if this is the first page.
if (empty($page)) {
    $page = 1;
}

echo COM_startBlock("STORY&nbsp;&nbsp;TO&nbsp;&nbsp;FORUM&nbsp;&nbsp;MIGRATION&nbsp;&nbsp;UTILITY&nbsp;&nbsp;-&nbsp;&nbsp;Version 0.92");

if (!empty($HTTP_GET_VARS['num_stories'])) {
	echo "<p>Completed ... Migrated {$HTTP_GET_VARS['num_stories']} topics and {$HTTP_GET_VARS['num_posts']} comments.<p />";
}

if (!empty($HTTP_POST_VARS['seltopic']) AND $HTTP_POST_VARS['seltopic'] != 'all') {
	$curtopic = $HTTP_POST_VARS['seltopic'];
	$sql = "select tid,sid,title,date,comments from {$_TABLES['stories']} where tid='$curtopic'";
	$countsql = DB_query("SELECT COUNT(*) FROM {$_TABLES['stories']} where tid='$curtopic'");
} else {
	$sql = "select tid,sid,title,date,comments from {$_TABLES['stories']}";
	$countsql = DB_query("SELECT COUNT(*) FROM {$_TABLES['stories']}");
}


list($maxrows) = DB_fetchArray($countsql);
$numpages = ceil($maxrows / $show);
$offset = ($page - 1) * $show;

$sql .= " ORDER BY sid DESC LIMIT $offset, $show";

$result  = DB_query($sql);
$numrows = DB_numROWS($result); 

echo '<table cellpadding="1" cellspacing="0" border="1" width="100%">';
echo '<form name="storymigrate" action="'.$PHP_SELF.'" method="post">';
echo '<tr>';

echo '<table cellpadding="1" cellspacing="0" border="0" width="100%">';
echo '<tr>';
echo '<td><select name="seltopic"><option value="all">All</option>' .LB . COM_optionList($_TABLES['topics'], "tid,topic",$curtopic) . '</select></td>';
echo '<td align="left"><input type="submit" value="Filter List"></td>';
echo '<td width="50%" align="right"><select name="selforum"><option value="select">Select Forum</option>' .LB. COM_optionList($_TABLES['gf_forums'], "forum_id,forum_name",$HTTP_POST_VARS['selforum']) . '</select></td>';
echo '<td align="left"><input type="submit" name="migrate" value="Migrate Selected Topics"></td>';
echo '</tr><tr><td colspan="4"><br><p /></td></tr></table>';


if ($numrows > 0) {

	// Add the Migrate all checkbox
    echo '<table cellpadding="1" cellspacing="0" border="0" width="100%">';
    echo '<tr>';
    echo '<td align="left" width="5%"><input type=checkbox name=cb_migrateall value=y 
		    onClick="if(!allChecked) checkAll(document.storymigrate.elements[\'cb_chkentry[]\']); 
			else uncheckAll(document.storymigrate.elements[\'cb_chkentry[]\']);">&nbsp;All</td>';
	// Header table for Story display
	echo '<td align="center" width="15%">Topic</td>';
	echo '<td align="left"   width="45%">Title</td>';
	echo '<td align="left"   width="25%">Date</td>';
	echo '<td align="left"   width="10%">Comments</td>';
    echo '</tr></table>';
    
	// Main table format for log display listing
	echo '<table cellpadding="1" cellspacing="0" border="1" width="100%"><tr>'; 

	$base_url = $_CONF['site_admin_url'] . '/plugins/forum/migrate.php?tid=$tid&mode=' .$mode. '&show='.$show. '&page='.$page;

	for ($i = 0; $i < DB_numrows($result); $i++) { 
		list($topic,$sid,$story,$date,$comments) = DB_fetchArray($result); 
		if ($i%2 == 0) {
			echo '<td bgcolor="E0E0E0" align="left" width="5%"><input type=checkbox name=cb_chkentry[] value="' .$sid.'"></td>';
			echo '<td bgcolor="E0E0E0"align="left" width="15%">' .stripslashes($topic).'</td>';
			echo '<td bgcolor="E0E0E0"align="left" width="45%"><a href="'.$_CONF['site_url'].'/article.php?story='.$sid.'">'.stripslashes($story).'</td>';
			echo '<td bgcolor="E0E0E0"align="left" width="25%">' .$date.'</td>';
			echo '<td bgcolor="E0E0E0"align="center" width="10%">' .$comments.'</td>';
		} else {
			echo '<td bgcolor="F6F6F0" align="left" width="5%"><input type=checkbox name=cb_chkentry[] value="' .$sid.'"></td>';
			echo '<td bgcolor="F6F6F0"align="left" width="15%">' .stripslashes($topic).'</td>';
			echo '<td bgcolor="F6F6F0"align="left" width="45%"><a href="'.$_CONF['site_url'].'/article.php?story='.$sid.'">'.stripslashes($story).'</td>';
			echo '<td bgcolor="F6F6F0"align="left" width="25%">' .$date.'</td>';
			echo '<td bgcolor="F6F6F0"align="center" width="10%">' .$comments.'</td>';
		}
		echo '</tr>';	
	}
	echo '<tr height="35" valign="middle"><td colspan="5" align="left">' . COM_printPageNavigation($base_url,$page, $numpages). '<br></td></tr>';

	echo '</table>';

}
echo '</tr></form></table>';

echo COM_endBlock();
echo COM_siteFooter();

?>
